## mingw-w64-cp2k-2026.1-1.src.tar.zst

=== CMakeLists.txt ===
#!-------------------------------------------------------------------------------------------------!
#!   CP2K: A general program to perform molecular dynamics simulations                             !
#!   Copyright 2000-2026 CP2K developers group <https://cp2k.org>                                  !
#!                                                                                                 !
#!   SPDX-License-Identifier: GPL-2.0-or-later                                                     !
#!-------------------------------------------------------------------------------------------------!

cmake_minimum_required(VERSION 3.24)

# include our cmake snippets
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# =================================================================================================
# REQUIRE OUT-OF-SOURCE BUILDS
file(TO_CMAKE_PATH "${PROJECT_BINARY_DIR}/CMakeLists.txt" LOC_PATH)
if(EXISTS "${LOC_PATH}")
  message(
    FATAL_ERROR
      "You cannot build in a source directory (or any directory with a CMakeLists.txt file). Please make a build subdirectory."
  )
endif()

# =================================================================================================
# PROJECT AND VERSION
include(CMakeDependentOption)
include(CustomTargets)

cmake_policy(SET CMP0048 NEW)

if(POLICY CMP0144)
  cmake_policy(SET CMP0144 NEW)
endif()

# !!! Keep version in sync with cp2k_info.F !!!
project(
  cp2k
  DESCRIPTION "CP2K"
  HOMEPAGE_URL "https://www.cp2k.org"
  VERSION "2026.1"
  LANGUAGES Fortran C CXX)

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/modules")

# set language and standard.
#
# cmake does not provide any mechanism to set the fortran standard. Adding the
# `std` option to compiler flags is the only way to control it. So leave them
# be.
#

if(NOT DEFINED CMAKE_CUDA_STANDARD)
  set(CMAKE_CUDA_STANDARD 14)
  set(CMAKE_CUDA_STANDARD_REQUIRED ON)
endif()

if(NOT DEFINED CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

if(NOT DEFINED CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
  set(CMAKE_C_STANDARD_REQUIRED ON)
endif()

if(NOT DEFINED CMAKE_HIP_STANDARD)
  set(CMAKE_HIP_STANDARD 14)
  set(CMAKE_HIP_STANDARD_REQUIRED ON)
endif()

# remove NDEBUG flag
string(REPLACE "-DNDEBUG" "" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
string(REPLACE "-DNDEBUG" "" CMAKE_CXX_FLAGS_RELEASE
               "${CMAKE_CXX_FLAGS_RELEASE}")
string(REPLACE "-DNDEBUG" "" CMAKE_Fortran_FLAGS_RELEASE
               "${CMAKE_Fortran_FLAGS_RELEASE}")
string(REPLACE "-DNDEBUG" "" CMAKE_C_FLAGS_RELWITHDEBINFO
               "${CMAKE_C_FLAGS_RELWITHDEBINFO}")
string(REPLACE "-DNDEBUG" "" CMAKE_CXX_FLAGS_RELWITHDEBINFO
               "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
string(REPLACE "-DNDEBUG" "" CMAKE_Fortran_FLAGS_RELWITHDEBINFO
               "${CMAKE_Fortran_FLAGS_RELWITHDEBINFO}")
string(REPLACE "-DNDEBUG" "" CMAKE_C_FLAGS_MINSIZEREL
               "${CMAKE_C_FLAGS_MINSIZEREL}")
string(REPLACE "-DNDEBUG" "" CMAKE_CXX_FLAGS_MINSIZEREL
               "${CMAKE_CXX_FLAGS_MINSIZEREL}")
string(REPLACE "-DNDEBUG" "" CMAKE_Fortran_FLAGS_MINSIZEREL
               "${CMAKE_Fortran_FLAGS_MINSIZEREL}")

find_package(PkgConfig)

# ##############################################################################
# Define the paths for static libraries and executables
# ##############################################################################
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY
    ${cp2k_BINARY_DIR}/lib
    CACHE PATH "Single output directory for building all libraries.")

# Search for rocm in common locations
foreach(__var ROCM_ROOT CRAY_ROCM_ROOT ORNL_ROCM_ROOT CRAY_ROCM_PREFIX
              ROCM_PREFIX CRAY_ROCM_DIR)
  if($ENV{${__var}})
    list(APPEND CMAKE_PREFIX_PATH $ENV{__var})
    set(ROCM_PATH
        $ENV{__var}
        CACHE PATH "Path to ROCm installation")
  endif()
endforeach()

# set(CMAKE_INSTALL_LIBDIR "lib" CACHE PATH "Default installation directory for
# libraries")

# =================================================================================================
# OPTIONS
option(CMAKE_POSITION_INDEPENDENT_CODE "Enable position independent code" ON)

option(CP2K_ENABLE_CONSISTENCY_CHECKS
       "Check that the list of compiled files and files contained in src match"
       OFF)

option(CP2K_USE_EVERYTHING
       "Enable all dependencies. They can be individually turned off again."
       OFF)

option(CP2K_USE_ACE "Enable ACE support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_DEEPMD "Enable DeePMD support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_DFTD4 "Enable DFTD4 support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_TBLITE "Enable TBLITE support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_FFTW3 "Enable FFTW3 support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_GREENX "Enable GreenX support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_HDF5 "Enable HDF5 support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_LIBINT2 "Enable Libint2 support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_LIBTORCH "Enable LibTorch support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_LIBXC "Enable LibXC support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_MPI "Enable MPI support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_PEXSI "Enable PEXSI support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_SPGLIB "Enable Spglib support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_TREXIO "Enable TREXIO support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_VORI "Enable Libvori support" ${CP2K_USE_EVERYTHING})
option(CP2K_USE_CRAY_PM_ENERGY "Enable Cray PM energy framework" OFF)
option(BUILD_SHARED_LIBS "Build CP2K shared library" ON)
option(
  CP2K_USE_FFTW3_WITH_MKL
  "MKL has its own compatible implementation of the FFTW3 library. This option, when ON, will use the separate and original FFTW3 library."
  OFF)

# MPI-enabled options
cmake_dependent_option(CP2K_USE_COSMA "Enable COSMA support"
                       ${CP2K_USE_EVERYTHING} "CP2K_USE_MPI" OFF)
cmake_dependent_option(CP2K_USE_DLAF "Enable DLA-Future support"
                       ${CP2K_USE_EVERYTHING} "CP2K_USE_MPI" OFF)
cmake_dependent_option(CP2K_USE_ELPA "Enable ELPA support"
                       ${CP2K_USE_EVERYTHING} "CP2K_USE_MPI" OFF)
cmake_dependent_option(CP2K_USE_LIBSMEAGOL "Enable LibSMEAGOL support"
                       ${CP2K_USE_EVERYTHING} "CP2K_USE_MPI" OFF)
cmake_dependent_option(CP2K_USE_MPI_F08 "Enable MPI Fortran 2008 interface"
                       ${CP2K_USE_EVERYTHING} "CP2K_USE_MPI" OFF)
cmake_dependent_option(CP2K_USE_PEXSI "Enable PEXSI support"
                       ${CP2K_USE_EVERYTHING} "CP2K_USE_MPI" OFF)
cmake_dependent_option(CP2K_USE_PLUMED "Enable PLUMED2 support"
                       ${CP2K_USE_EVERYTHING} "CP2K_USE_MPI" OFF)
cmake_dependent_option(CP2K_USE_SIRIUS "Enable SIRIUS support"
                       ${CP2K_USE_EVERYTHING} "CP2K_USE_MPI" OFF)
cmake_dependent_option(CP2K_USE_SPLA "Enable SpLA support"
                       ${CP2K_USE_EVERYTHING} "CP2K_USE_MPI" OFF)
cmake_dependent_option(CP2K_USE_MIMIC "Enable MIMIC support"
                       ${CP2K_USE_EVERYTHING} "CP2K_USE_MPI" OFF)
cmake_dependent_option(
  CP2K_USE_LIBXSMM "Enable libxsmm support" ${CP2K_USE_EVERYTHING}
  "NOT CP2K_USE_ACCEL MATCHES \"OPENCL\"" ON)
cmake_dependent_option(CP2K_USE_LIBVDWXC "Enable libvdwxc support with SIRIUS"
                       ${CP2K_USE_EVERYTHING} "CP2K_USE_SIRIUS" OFF)

# do not turn it on if sirius is built with the toolchain
cmake_dependent_option(
  CP2K_USE_SIRIUS_DFTD4 "Enable dftd3 and dftd4 sirius support" OFF
  "CP2K_USE_SIRIUS" OFF)
cmake_dependent_option(
  CP2K_USE_SIRIUS_VCSQNM "Enable variable cell shape relaxation in SIRIUS" OFF
  "CP2K_USE_SIRIUS" OFF)

cmake_dependent_option(CP2K_USE_SIRIUS_NLCG "Enable nlcg method in SIRIUS" OFF
                       "CP2K_USE_SIRIUS" OFF)

cmake_dependent_option(
  CP2K_DBCSR_USE_CPU_ONLY "Disable the DBCSR accelerated backend" OFF
  "NOT CP2K_USE_ACCEL MATCHES \"OPENCL|HIP|CUDA\"" OFF)

cmake_dependent_option(
  CP2K_ENABLE_DBM_GPU "Enable the dbm accelerated backend (mostly GPU)." ON
  "CP2K_USE_ACCEL" OFF)

cmake_dependent_option(
  CP2K_ENABLE_GRID_GPU "Enable acceleration for grid related functions." ON
  "CP2K_USE_ACCEL MATCHES \"HIP|CUDA\"" OFF)

cmake_dependent_option(
  CP2K_ENABLE_PW_GPU "Enable the ffts accelerated backend (mostly GPU)." ON
  "CP2K_USE_ACCEL MATCHES \"HIP|CUDA\"" OFF)

cmake_dependent_option(
  CP2K_USE_UNIFIED_MEMORY "Use CPU/GPU unified memory (Mi250x onwards)" OFF
  "CP2K_USE_ACCEL MATCHES \"HIP\"" OFF)

cmake_dependent_option(CP2K_ENABLE_ELPA_OPENMP_SUPPORT
                       "Enable ELPA OpenMP support" ON "CP2K_USE_ELPA" OFF)
cmake_dependent_option(CP2K_ENABLE_FFTW3_OPENMP_SUPPORT
                       "Enable FFTW3 OpenMP support" ON "CP2K_USE_FFTW3" OFF)
cmake_dependent_option(CP2K_ENABLE_FFTW3_THREADS_SUPPORT
                       "Enable FFTW3 threads support" OFF "CP2K_USE_FFTW3" OFF)

cmake_dependent_option(
  CP2K_USE_CUSOLVER_MP
  "Use Nvidia GPU accelerated eigensolver. Only active when CUDA is ON" OFF
  "CP2K_USE_ACCEL MATCHES \"CUDA\"" OFF)

cmake_dependent_option(CP2K_USE_NVHPC OFF "Enable Nvidia NVHPC kit"
                       "(NOT CP2K_USE_ACCEL MATCHES \"CUDA\")" OFF)

cmake_dependent_option(
  CP2K_USE_SPLA_GEMM_OFFLOADING ON
  "Enable SpLA dgemm offloading (only valid with GPU support on)"
  "(NOT CP2K_USE_ACCEL MATCHES \"NONE\") AND (CP2K_USE_SPLA)" OFF)

cmake_dependent_option(
  CP2K_USE_CRAY_PM_ACCEL_ENERGY ON
  "Enable CRAY power management framework with gpu support"
  "(NOT CP2K_USE_ACCEL MATCHES \"NONE\") AND (CP2K_USE_CRAY_PM_ENERGY)" OFF)

cmake_dependent_option(
  CP2K_USE_LIBVDWXC OFF
  "Compile CP2K with libvdwxc support when SIRIUS is compiled with it"
  "CP2K_USE_SIRIUS" OFF)

set(CP2K_BLAS_VENDOR
    "auto"
    CACHE STRING "blas vendor/generic libraries")

set_property(
  CACHE CP2K_BLAS_VENDOR
  PROPERTY STRINGS
           "auto"
           "MKL"
           "OpenBLAS"
           "SCI"
           "GenericBLAS"
           "Armpl"
           "FlexiBLAS"
           "Atlas"
           "NVHPCBlas"
           "CUSTOM")

set(CP2K_SCALAPACK_VENDOR_LIST "MKL" "SCI" "GENERIC" "auto")
set(CP2K_SCALAPACK_VENDOR
    "auto"
    CACHE STRING "ScaLAPACK vendor/generic backend")
set_property(CACHE CP2K_SCALAPACK_VENDOR PROPERTY STRINGS
                                                  ${CP2K_SCALAPACK_VENDOR_LIST})

if(DEFINED CP2K_SCALAPACK_VENDOR)
  if(NOT ${CP2K_SCALAPACK_VENDOR} IN_LIST CP2K_SCALAPACK_VENDOR_LIST)
    message(FATAL_ERROR "An invalid ScaLAPACK vendor backend was specified")
  endif()
endif()

set(CP2K_DATA_DIR
    "default"
    CACHE STRING "Set the location for CP2K data")

# ##############################################################################
# GPU related options
# ##############################################################################

set(CP2K_SUPPORTED_ACCELERATION_TARGETS CUDA HIP OPENCL NONE)
set(CP2K_SUPPORTED_CUDA_ARCHITECTURES
    K20X
    K40
    K80
    P100
    V100
    A100
    H100
    A40)
set(CP2K_SUPPORTED_HIP_ARCHITECTURES
    Mi50
    Mi100
    Mi210
    Mi250
    Mi300
    K20X
    K40
    K80
    P100
    V100
    A100
    H100
    A40)

set(CP2K_WITH_GPU
    "NONE"
    CACHE STRING
          "Set the CUDA GPU architecture if HIP is enabled (default: NONE)")

set_property(
  CACHE CP2K_WITH_GPU PROPERTY STRINGS ${CP2K_SUPPORTED_CUDA_ARCHITECTURES}
                               ${CP2K_SUPPORTED_HIP_ARCHITECTURES})

set(CP2K_USE_ACCEL
    "NONE"
    CACHE STRING "Set hardware acceleration support: CUDA, HIP, OPENCL")

set_property(CACHE CP2K_USE_ACCEL
             PROPERTY STRINGS ${CP2K_SUPPORTED_ACCELERATION_TARGETS})

# ##############################################################################
# specific variables for the regtests. Binaries will be created with an
# extension
# ##############################################################################

=== src/CMakeLists.txt ===
#!-------------------------------------------------------------------------------------------------!
#!   CP2K: A general program to perform molecular dynamics simulations                             !
#!   Copyright 2000-2026 CP2K developers group <https://cp2k.org>                                  !
#!                                                                                                 !
#!   SPDX-License-Identifier: GPL-2.0-or-later                                                     !
#!-------------------------------------------------------------------------------------------------!

include(fypp-sources)
include(cp2k_utils)
include(GNUInstallDirs) # required to get a proper LIBDIR variable
include(CMakePackageConfigHelpers)
configure_file(base/base_uses.f90 base/base_uses.f90 @ONLY)

# =================================================================================================
# SOURCE FILE LISTS
# =================================================================================================

# do not worry about formatting or sorting. make pretty will fix this for you

# the sources files are split by directory which hopefully make the list a bit
# clearer. Any Fortran new file can be added to CP2K_SRCS_F list. the list
# sorted but it is *not* a requirement. C files should be added preferencially
# to CP2K_SRCS_C etc....
#
# The other option is to simply create a new list with the syntax list(APPEND
# MY_FOO foo.c foo.F foo.cu) and add this list to the list of files to compile.

list(
  APPEND
  CP2K_SRCS_F
  ace_nlist.F
  ace_wrapper.F
  admm_dm_methods.F
  admm_dm_types.F
  admm_methods.F
  admm_types.F
  admm_utils.F
  almo_scf_diis_types.F
  almo_scf_env_methods.F
  almo_scf.F
  almo_scf_lbfgs_types.F
  almo_scf_methods.F
  almo_scf_optimizer.F
  almo_scf_qs.F
  almo_scf_types.F
  al_system_types.F
  atom_admm_methods.F
  atom_basis.F
  atom_electronic_structure.F
  atom_energy.F
  atom.F
  atom_fit.F
  atom_grb.F
  atomic_charges.F
  atom_kind_orbitals.F
  atom_operators.F
  atom_optimization.F
  atom_output.F
  atom_pseudo.F
  atom_set_basis.F
  atom_sgp.F
  atoms_input.F
  atom_types.F
  atom_upf.F
  atom_utils.F
  atom_xc.F
  auto_basis.F
  post_scf_bandstructure_methods.F
  soc_pseudopotential_methods.F
  soc_pseudopotential_utils.F
  basis_set_output.F
  beta_gamma_psi.F
  block_p_types.F
  bse_main.F
  bse_full_diag.F
  bse_iterative.F
  bse_print.F
  bse_properties.F
  bse_util.F
  bsse.F
  cell_methods.F
  colvar_methods.F
  colvar_utils.F
  commutator_rkinetic.F
  commutator_rpnl.F
  constraint_3x3.F
  constraint_4x6.F
  constraint_clv.F
  constraint.F
  constraint_fxd.F
  constraint_util.F
  constraint_vsite.F
  greenx_interface.F
  core_ae.F
  core_ppl.F
  core_ppnl.F
  cp2k_debug.F
  cp2k_info.F
  cp_control_types.F
  cp_control_utils.F
  cp_dbcsr_cholesky.F
  cp_dbcsr_cp2k_link.F
  cp_dbcsr_diag.F
  cp_dbcsr_operations.F
  cp_dbcsr_output.F
  cp_ddapc.F
  cp_ddapc_forces.F
  cp_ddapc_methods.F
  cp_ddapc_types.F
  cp_ddapc_util.F
  cp_eri_mme_interface.F
  cp_external_control.F
  parallel_gemm_api.F
  cp_realspace_grid_cube.F
  cp_realspace_grid_init.F
  cp_subsys_methods.F
  cp_symmetry.F
  cryssym.F
  csvr_system_types.F
  csvr_system_utils.F
  ct_methods.F
  ct_types.F
  debug_os_integrals.F
  deepmd_wrapper.F
  dft_plus_u.F
  dgemm_counter_types.F
  distribution_2d_types.F
  distribution_methods.F
  dkh_main.F
  dm_ls_chebyshev.F
  dm_ls_scf_create.F
  dm_ls_scf_curvy.F
  dm_ls_scf.F
  dm_ls_scf_methods.F
  dm_ls_scf_qs.F
  dm_ls_scf_types.F
  domain_submatrix_methods.F
  domain_submatrix_types.F
  eeq_data.F
  eeq_input.F
  eeq_method.F
  ec_efield_local.F
  ec_environment.F
  ec_env_types.F
  ec_external.F
  ec_methods.F
  ec_orth_solver.F
  ed_analysis.F
  efield_tb_methods.F
  efield_utils.F
  eip_environment.F
  eip_environment_types.F
  eip_silicon.F
  embed_environment.F
  embed_main.F
  embed_types.F
  energy_corrections.F
  environment.F
  eri_mme/eri_mme_error_control.F
  eri_mme/eri_mme_gaussian.F
  eri_mme/eri_mme_integrate.F
  eri_mme/eri_mme_lattice_summation.F
  eri_mme/eri_mme_test.F
  eri_mme/eri_mme_types.F
  eri_mme/eri_mme_util.F
  et_coupling.F
  et_coupling_proj.F
  et_coupling_types.F
  ewald_environment_types.F
  ewald_methods_tb.F
  ewald_pw_methods.F
  ewald_pw_types.F
  ewalds.F
  ewalds_multipole.F
  ewald_spline_util.F
  excited_states.F
  exclusion_types.F
  ex_property_calculation.F
  exstates_types.F
  extended_system_types.F
  external_potential_methods.F
  f77_interface.F
  farming_methods.F
  farming_types.F
  fermi_utils.F
  fist_efield_methods.F
  fist_efield_types.F
  fist_energy_types.F
  fist_environment.F
  fist_environment_types.F
  fist_force.F
  fist_intra_force.F
  fist_main.F
  fist_neighbor_list_control.F
  fist_neighbor_lists.F
  fist_neighbor_list_types.F
  fist_nonbond_env_types.F
  fist_nonbond_force.F
  fist_pol_scf.F
  force_env_methods.F
  force_env_types.F
  force_env_utils.F
  force_fields_all.F
  force_fields_ext.F
  force_fields.F
  force_fields_input.F
  force_fields_util.F
  force_field_types.F
  fp_methods.F
  fp_types.F
  free_energy_types.F
  generic_os_integrals.F
  gle_system_types.F
  global_types.F
  graphcon.F
  grid/grid_api.F
  group_dist_types.F
  grrm_utils.F
  gapw_1c_basis_set.F
  gw_communication.F
  gw_main.F
  gw_large_cell_gamma.F
  gw_small_cell_full_kp.F
  post_scf_bandstructure_types.F
  post_scf_bandstructure_utils.F
  gw_utils.F
  gw_integrals.F
  hairy_probes.F
  hartree_local_methods.F
  hartree_local_types.F
  header.F
  hfx_admm_utils.F
  hfx_communication.F
  hfx_compression_methods.F
  hfx_derivatives.F
  hfx_energy_potential.F
  hfx_exx.F
  hfx_helpers.F
  hfx_libint_interface.F
  hfx_load_balance_methods.F
  hfx_pair_list_methods.F
  hfx_pw_methods.F
  hfx_ri.F
  hfx_ri_kp.F
  hfx_screening_methods.F
  hfx_types.F
  hirshfeld_methods.F
  hirshfeld_types.F
  input_constants.F
  input_cp2k_almo.F
  input_cp2k_atom.F
  input_cp2k_atprop.F
  input_cp2k_binary_restarts.F
  input_cp2k_check.F
  input_cp2k_colvar.F
  input_cp2k_constraints.F
  input_cp2k_dft.F
  input_cp2k_harris.F
  input_cp2k_print_dft.F
  input_cp2k_scf.F
  input_cp2k_as.F
  input_cp2k_opt.F
  input_cp2k_qs.F
  input_cp2k_se.F
  input_cp2k_xas.F
  input_cp2k_distribution.F
  input_cp2k_ec.F
  input_cp2k_eip.F
  input_cp2k_embed.F
  input_cp2k_exstate.F
  input_cp2k_external.F
  input_cp2k_field.F
  input_cp2k_force_eval.F
  input_cp2k_free_energy.F
  input_cp2k_global.F
  input_cp2k_hfx.F
  input_cp2k_kpoints.F
  input_cp2k_loc.F
  input_cp2k_ls.F
  input_cp2k_mixed.F
  input_cp2k_mm.F
  input_cp2k_motion_print.F
  input_cp2k_mp2.F
  input_cp2k_neb.F
  input_cp2k_negf.F
  input_cp2k_nnp.F
  input_cp2k_poisson.F
  input_cp2k_projection_rtp.F
  input_cp2k_properties_dft.F
  input_cp2k_pwdft.F
  input_cp2k_qmmm.F
  input_cp2k_read.F
  input_cp2k_resp.F
  input_cp2k_restarts_util.F
  input_cp2k_rsgrid.F
  input_cp2k_subsys.F
  input_cp2k_smeagol.F
  input_cp2k_tb.F
  input_cp2k_thermostats.F
  input_cp2k_transport.F
  input_cp2k_voronoi.F
  input_cp2k_xc.F
  input_optimize_basis.F
  input_optimize_input.F
  input_restart_force_eval.F
  input_restart_rng.F
  integration_grid_types.F
  iao_analysis.F
  iao_types.F
  ipi_driver.F
  ipi_environment.F
  ipi_environment_types.F
  ipi_server.F
  iterate_matrix.F
  kg_correction.F
  kg_environment.F
  kg_environment_types.F
  kg_tnadd_mat.F
  kg_vertex_coloring_methods.F
  kpoint_coulomb_2c.F
  kpoint_io.F
  kpoint_k_r_trafo_simple.F
  kpoint_methods.F
  kpoint_transitional.F
  kpoint_types.F
  kpsym.F
  libgrpp_integrals.F
  libint_2c_3c.F
  libint_wrapper.F
  library_tests.F
  linesearch.F
  localization_tb.F
  lri_compression.F
  lri_environment_init.F
  lri_environment_methods.F
  lri_environment_types.F
  lri_forces.F
  lri_integrals.F
  lri_ks_methods.F
  lri_optimize_ri_basis.F
  lri_optimize_ri_basis_types.F
  ls_matrix_exp.F
  manybody_eam.F
  manybody_deepmd.F
  manybody_gal21.F
  manybody_gal.F
  manybody_allegro.F
  manybody_nequip.F
  manybody_potential.F
  manybody_siepmann.F
  manybody_tersoff.F
  manybody_ace.F
  mao_basis.F
  mao_methods.F
  mao_optimizer.F
  mao_wfn_analysis.F
  matrix_exp.F
  maxwell_solver_interface.F
  mdctrl_types.F
  metadynamics.F
  metadynamics_types.F
  metadynamics_utils.F
  metadyn_tools/graph_methods.F
  metadyn_tools/graph_utils.F
  min_basis_set.F
  minbas_methods.F
  minbas_wfn_analysis.F
  mixed_cdft_methods.F
  mixed_cdft_types.F
  mixed_cdft_utils.F
  mixed_energy_types.F
  mixed_environment.F
  mixed_environment_types.F
  mixed_environment_utils.F
  mixed_main.F
  mm_collocate_potential.F
  mm_mapping_library.F
  mode_selective.F
  molden_utils.F
  molecular_dipoles.F
  molecular_moments.F
  molecular_states.F
  mol_force.F
  molsym.F
  moments_utils.F
  motion_utils.F
  mp2_cphf.F
  mp2_direct_method.F
  mp2_eri.F
  mp2_eri_gpw.F
  mp2.F
  mp2_gpw.F
  mp2_gpw_method.F
  mp2_grids.F
  mp2_integrals.F
  mp2_laplace.F
  mp2_optimize_ri_basis.F
  mp2_ri_2c.F
  mp2_ri_gpw.F
  mp2_ri_grad.F
  mp2_ri_grad_util.F
  mp2_ri_libint.F
  mp2_setup.F
  mp2_types.F
  mscfg_methods.F
  mscfg_types.F
  mulliken.F
  negf_alloc_types.F
  negf_atom_map.F
  negf_control_types.F
  negf_env_types.F
  negf_green_cache.F
  negf_green_methods.F
  negf_integr_cc.F
  negf_integr_simpson.F
  negf_integr_utils.F
  negf_io.F
  negf_matrix_utils.F
  negf_methods.F
  negf_subgroup_types.F
  negf_vectors.F
  nnp_acsf.F
  nnp_environment.F
  nnp_environment_types.F
  nnp_force.F
  nnp_model.F
  local_gemm_api.F
  offload/offload_api.F
  optbas_fenv_manipulation.F
  optbas_opt_utils.F
  optimize_basis.F
  optimize_basis_types.F
  optimize_basis_utils.F
  optimize_dmfet_potential.F
  optimize_embedding_potential.F
  optimize_input.F
  outer_scf_control_types.F
  paw_proj_set_types.F
  pair_potential_coulomb.F
  pair_potential.F
  pair_potential_types.F
  pair_potential_util.F
  pao_input.F
  pao_io.F
  pao_linpot_full.F
  pao_linpot_rotinv.F
  pao_main.F
  pao_methods.F
  pao_ml_descriptor.F
  pao_ml.F
  pao_ml_gaussprocess.F
  pao_ml_neuralnet.F
  pao_model.F
  pao_optimizer.F
  pao_param_exp.F
  pao_param.F
  pao_param_equi.F
  pao_param_fock.F
  pao_param_gth.F
  pao_param_linpot.F
  pao_param_methods.F
  pao_potentials.F
  pao_types.F
  particle_methods.F
  paw_proj_set_types.F
  pexsi_interface.F
  pexsi_methods.F
  pexsi_types.F
  pilaenv_hack.F
  pme.F
  pme_tools.F
  population_analyses.F
  preconditioner_apply.F
  preconditioner.F
  preconditioner_makes.F
  preconditioner_solvers.F
  preconditioner_types.F
  qmmm_create.F
  qmmm_elpot.F
  qmmm_ff_fist.F
  qmmm_force.F
  qmmm_gaussian_data.F
  qmmm_gaussian_init.F
  qmmm_gaussian_input.F
  qmmm_gaussian_types.F
  qmmm_gpw_energy.F
  qmmm_gpw_forces.F
  qmmm_image_charge.F
  qmmm_init.F
  qmmm_links_methods.F
  qmmm_per_elpot.F
  qmmm_pw_grid.F
  qmmm_se_energy.F
  qmmm_se_forces.F
  qmmm_tb_coulomb.F
  qmmm_tb_methods.F
  qmmm_topology_util.F
  qmmm_types.F
  qmmm_types_low.F
  qmmm_util.F
  qmmmx_create.F
  qmmmx_force.F
  qmmmx_types.F
  qmmmx_update.F
  qmmmx_util.F
  qs_2nd_kernel_ao.F
  qs_active_space_methods.F
  qs_active_space_types.F
  qs_active_space_utils.F
  qcschema.F
  hdf5_wrapper.F
  sockets_interface.F
  qs_apt_fdiff_methods.F
  qs_apt_fdiff_types.F
  qs_atomic_block.F
  qs_band_structure.F
  qs_basis_gradient.F
  qs_basis_rotation_methods.F
  qs_block_davidson_types.F
  qs_cdft_methods.F
  qs_cdft_opt_types.F
  qs_cdft_scf_utils.F
  qs_cdft_types.F
  qs_cdft_utils.F
  qs_charge_mixing.F
  qs_chargemol.F
  qs_charges_types.F
  qs_cneo_ggrid.F
  qs_cneo_methods.F
  qs_cneo_types.F
  qs_cneo_utils.F
  qs_collocate_density.F
  qs_commutators.F
  qs_condnum.F
  qs_core_energies.F
  qs_core_hamiltonian.F
  qs_core_matrices.F
  qs_dcdr_ao.F
  qs_dcdr.F
  qs_dcdr_utils.F
  qs_density_matrices.F
  qs_density_mixing_types.F
  qs_dftb3_methods.F
  qs_dftb_coulomb.F
  qs_dftb_dispersion.F
  qs_dftb_matrices.F
  qs_dftb_parameters.F
  qs_dftb_types.F

=== src/dbm/Makefile ===
PROJHOME := $(abspath $(dir $(lastword $(MAKEFILE_LIST))))
CP2KHOME := $(abspath $(PROJHOME)/../..)
OMP_TRACE := $(wildcard $(PROJHOME)/../base/openmp_trace.c)
ALL_HEADERS := $(shell find . -name "*.h") $(shell find ../offload/ -name "*.h")
ALL_OBJECTS :=  $(OMP_TRACE:.c=.o) \
        ../offload/offload_library.o \
        ../offload/offload_mempool.o \
        ../mpiwrap/cp_mpi.o \
        dbm_distribution.o \
        dbm_library.o \
        dbm_matrix.o \
        dbm_multiply.o \
        dbm_multiply_comm.o \
        dbm_multiply_cpu.o \
        dbm_shard.o

# Optimization level
ifeq (,$(filter-out 0,$(DBG)))
OPT ?= 3
else
OPT ?= 0
endif

# Optimization flag derived from OPT flag
OPTFLAG ?= -O$(patsubst O%,%,$(OPT))

CFLAGS := -fPIC -g $(OPTFLAG) -march=native -Wall -Wextra -Wcast-qual

VALIDATE ?= 0
ifneq ($(VALIDATE),0)
CFLAGS += -DDBM_VALIDATE_AGAINST_LIBXSMM
endif

# Intel Compiler
ICX := $(shell which icx 2>/dev/null)
INTEL ?= $(if $(ICX),$(if $(filter-out 0,$(GNU)),0,1),0)

# Build with MPI when MPICC is given
MPI ?= $(if $(MPICC),1,0)

ifeq ($(INTEL),0)
MKL_FCRTL := gf
LIBS += $(if $(OMPRT),-l$(OMPRT),-fopenmp)
CFLAGS += -fopenmp -Wno-vla-parameter
CC := $(if $(filter-out 0,$(MPI)),mpicc,gcc)
else
MKL_FCRTL := intel
LIBS += $(if $(OMPRT),-fopenmp -Wno-recommended-option,-qopenmp)
CFLAGS += $(if $(OMPRT),-fopenmp -Wno-recommended-option,-qopenmp)
CC := $(if $(filter-out 0,$(MPI)),mpiicx,icx)
endif

ifneq ($(MPI),0)
CFLAGS += -D__parallel
ifneq ($(MPICC),)
CC := $(MPICC)
endif
endif

ifeq ($(filter-out 0,$(OPENCL)),)
NVCC := $(shell which nvcc 2>/dev/null)
NVARCH := sm_70
NVFLAGS := -g $(OPTFLAG) -lineinfo -arch $(NVARCH) -Wno-deprecated-gpu-targets -Xcompiler "$(CFLAGS)" -D__OFFLOAD_CUDA

HIPCC := $(shell which hipcc 2>/dev/null)
HIPARCH := gfx90a
ROCM_PATH_ENV := $(shell echo "$${ROCM_PATH}")
ROCM_PATH := $(if $(ROCM_PATH_ENV),$(ROCM_PATH_ENV),/opt/rocm)
HIPFLAGS := -fPIE -g $(OPTFLAG) --offload-arch=$(HIPARCH) -Wall -Wextra -Werror -I${ROCM_PATH}/include -D__OFFLOAD_HIP -D__HIP_PLATFORM_AMD__ -D__HIP_PLATFORM_AMD__
endif

# prefer NVCC or HIPCC over OpenCL
ifneq ($(NVCC)$(HIPCC),)
NVCC_PATH := $(if $(NVCC),$(wildcard $(dir $(NVCC))/..))
CUDA_FILE := $(wildcard $(NVCC_PATH)/../cuda/include/cuda.h)
CUDA_PATH := $(if $(CUDA_FILE),$(NVCC_PATH)/../cuda,$(NVCC_PATH))
CUDA_LIBS := $(if $(wildcard $(CUDA_PATH)/lib64),lib64,lib)
OPENCL := 0
endif
ifneq ($(OPENCL),0)
OPENCL_OFFLOAD := $(firstword $(wildcard $(CP2KHOME)/lib/*/*/exts/dbcsr/libdbcsr.a))
OPENCL_GENKRNL := $(PROJHOME)/dbm_multiply_opencl.cl.h
ifneq ($(ICX),)
LIBS += -lifcoremt -limf
endif
endif

# Make foundational runtimes available
LIBS += -ldl -lstdc++ -lc -lm


# Make BLAS/LAPACK available
ifneq ($(MKLROOT),)
LIBS += -L$(MKLROOT)/lib/intel64 \
        -Wl,--start-group \
        -lmkl_$(MKL_FCRTL)_lp64 \
        -lmkl_core \
        -lmkl_sequential \
        -Wl,--end-group
else ifneq ($(OPENBLAS),0)
LIBS += -lopenblas
else
LIBS += -lblas
endif

.PHONY : all clean

all: dbm_miniapp.x

clean:
	rm -fv $(ALL_OBJECTS) $(OPENCL_GENKRNL) \
        dbm_multiply_gpu.o \
        dbm_multiply_gpu_kernel.o \
        dbm_multiply_opencl.o \
        dbm_miniapp.o

realclean: clean
	rm -fv dbm_miniapp.x


# Enable OpenCL when DBCSR library was prebuilt (assume __DBCSR_ACC).
ifneq ($(OPENCL_OFFLOAD),)
OPENCL_SRC := $(PROJHOME)/dbm_multiply_opencl.cl
OPENCL_CMN := $(wildcard $(CP2KHOME)/exts/dbcsr/src/acc/opencl/common/*.h)
OPENCL_GEN := $(CP2KHOME)/exts/dbcsr/src/acc/opencl/acc_opencl.sh
ALL_HEADERS += $(OPENCL_GENKRNL)

ALL_OBJECTS += dbm_multiply_gpu.o dbm_multiply_opencl.o
CFLAGS += -I$(CP2KHOME)/exts/dbcsr/src/acc/opencl -I$(CP2KHOME)/exts/dbcsr
CFLAGS += -D__OFFLOAD_OPENCL -D__DBCSR_ACC
LIBS += $(OPENCL_OFFLOAD) -lgfortran

ifneq (Darwin,$(shell uname))
OPENCL_LIB := $(shell ldconfig -p 2>/dev/null | grep -m1 OpenCL | rev | cut -d' ' -f1 | rev)
ifeq (,$(OPENCL_LIB))
OPENCL_LIB := /usr/lib/x86_64-linux-gnu/libOpenCL.so.1
endif
ifneq (,$(CUDA_PATH))
ifeq (,$(wildcard $(OPENCL_INC)))
CFLAGS += -I$(CUDA_PATH)/include
endif
ifeq (,$(wildcard $(OPENCL_LIB)))
LIBS += -L$(CUDA_PATH)/$(CUDA_LIBS)
LIBS += -Wl,-rpath=$(CUDA_PATH)/$(CUDA_LIBS)
endif
else ifneq (,$(wildcard $(OPENCL_ROOT)/include/CL/cl.h))
ifeq (,$(wildcard $(OPENCL_INC)))
CFLAGS += -I$(OPENCL_ROOT)/include
endif
LIBS += -L$(OPENCL_ROOT)/$(if $(wildcard $(OPENCL_ROOT)/lib64),lib64,lib)
else ifneq (,$(ICX))
OPENCL_ROOT := $(abspath $(dir $(ICX))/..)
CLINC := $(wildcard $(OPENCL_ROOT)/include/sycl/CL/cl.h $(OPENCL_ROOT)/include/CL/cl.h)
ifneq (,$(CLINC))
LIBS += -L$(OPENCL_ROOT)/$(if $(wildcard $(OPENCL_ROOT)/lib64),lib64,lib)
LIBS += -L$(OPENCL_ROOT)/compiler/lib/intel64 -lintlc
ifeq (,$(wildcard $(OPENCL_INC)))
CFLAGS += -I$(abspath $(dir $(firstword $(CLINC)))/..)
endif
endif
endif
# OPENCL_INC: directory containing CL/cl.h.
ifneq (,$(wildcard $(OPENCL_INC)))
CFLAGS += -I$(OPENCL_INC)
endif
# OPENCL_LIB: file/library to be linked
ifneq (,$(wildcard $(OPENCL_LIB)))
LIBS += $(OPENCL_LIB)
else
LIBS += -l:libOpenCL.so.1
endif
else # macOS
LIBS += -framework OpenCL
endif

dbm_miniapp.x: $(OPENCL_OFFLOAD)
$(OPENCL_GENKRNL): $(OPENCL_GEN) $(OPENCL_SRC) $(OPENCL_CMN)
	$(OPENCL_GEN) -b 6 -p "" $(OPENCL_SRC) $@


# Enable Cuda when nvcc compiler is present.
else ifneq ($(NVCC),)
ALL_OBJECTS += dbm_multiply_gpu.o dbm_multiply_gpu_kernel.o
CFLAGS += -I${CUDA_PATH}/include -D__OFFLOAD_CUDA
LIBS += -lcudart -lcuda -lcublas -L${CUDA_PATH}/$(CUDA_LIBS)
ifneq ($(wildcard $(NVCC_PATH)/../math_libs/$(CUDA_LIBS)),)
LIBS += -L$(NVCC_PATH)/../math_libs/$(CUDA_LIBS)
endif

%.o: %.cu $(ALL_HEADERS)
	cd $(dir $<); $(NVCC) -c $(NVFLAGS) $(notdir $<)


# Enable HIP/ROCm when hipcc compiler is present.
else ifneq ($(HIPCC),)
ALL_OBJECTS += dbm_multiply_gpu.o dbm_multiply_gpu_kernel.o
CFLAGS += -I${ROCM_PATH}/include -D__OFFLOAD_HIP -D__HIP_PLATFORM_AMD__
LIBS += -L${ROCM_PATH}/lib -lamdhip64 -lhipfft -lhipblas -lrocblas

%.o: %.cu $(ALL_HEADERS)
	cd $(dir $<); $(HIPCC) -c $(HIPFLAGS) $(notdir $<)
endif

# Make LIBXSMM available
ifneq ($(LIBXSMMROOT),)
CFLAGS += -D__LIBXSMM -I$(LIBXSMMROOT)/include
LIBS += $(LIBXSMMROOT)/lib/libxsmm.a \
        $(LIBXSMMROOT)/lib/libxsmmext.a \
        -lpthread -lrt
endif

%.o: %.c $(OMP_TRACE) $(ALL_HEADERS)
	cd $(dir $<); $(CC) -c -std=c11 $(CFLAGS) $(notdir $<)

dbm_miniapp.x: dbm_miniapp.o $(ALL_OBJECTS)
	$(CC) -o $@ $^ $(LIBS)

#EOF

=== tools/pao-ml/requirements.txt ===
nequip==0.16.1
torch
numpy
e3nn

#EOF

=== tools/precommit/requirements.txt ===
black==24.3.0
blinker==1.7.0
click==8.1.7
cmake-format==0.6.13
cmakelang==0.6.13
Flask==3.0.0
fortitude-lint==0.7.5
gunicorn==23.0.0
itsdangerous==2.1.2
Jinja2==3.1.6
linkify-it-py==2.0.2
markdown-it-py==2.2.0
MarkupSafe==2.1.3
mdformat==0.7.17
mdformat-gfm==0.3.5
mdformat_frontmatter==2.0.1
mdformat_myst==0.1.5
mdformat_tables==0.4.1
mdit-py-plugins==0.3.5
mdurl==0.1.2
mypy-extensions==1.0.0
packaging==23.2
pathspec==0.11.2
platformdirs==4.0.0
ruamel.yaml==0.18.5
ruamel.yaml.clib==0.2.8
six==1.16.0
tomli==2.0.1
typing_extensions==4.8.0
uc-micro-py==1.0.2
Werkzeug==3.1.4

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=cp2k
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2026.1
pkgrel=1
pkgdesc="A quantum chemistry and solid state physics software package (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64')
url='https://www.cp2k.org'
msys2_repository_url="https://github.com/cp2k/cp2k"
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-dbcsr"
         #"${MINGW_PACKAGE_PREFIX}-dftd4"
         "${MINGW_PACKAGE_PREFIX}-fftw"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libint2"
         "${MINGW_PACKAGE_PREFIX}-libxc"
         $([[ ${CARCH} == aarch64 ]] || echo "${MINGW_PACKAGE_PREFIX}-libxsmm")
         "${MINGW_PACKAGE_PREFIX}-mctc-lib"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         #"${MINGW_PACKAGE_PREFIX}-opencl-icd"
         "${MINGW_PACKAGE_PREFIX}-spglib"
         "${MINGW_PACKAGE_PREFIX}-tblite")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-python")
             #"${MINGW_PACKAGE_PREFIX}-opencl-headers")
source=("https://github.com/cp2k/cp2k/releases/download/v${pkgver}/${_realname}-${pkgver}.tar.bz2"
        "001-fix-build-on-mingw-w64.patch"
        "002-fix-conflict-with-cmake-find-lapack.patch"
        "003-make-tblite-independent-from-dftd4.patch"
        "004-Fix-build-without-MPI.patch")
sha256sums=('4364c74bcffaa474bc234e11686b09550e4d06932acf2147a341e4f7679dd88e'
            'c52ad5fe1c2e128ba1773cacf2d0783f0b95b33b82a131f460a9aa2568576e30'
            'fb29a3611a197849655031ac62a54fa1f97c147aae3c00251fb99f73789f8751'
            'd2e282f673f5697e2fabb6041a5f7540c1b4556a8da57430c4200a8ee3c1ebe5'
            '957fa2c9dba75fbafa78db90ab9312de04de398bd48c1365e68fc4b8d8fa6656')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd ${_realname}-${pkgver}
  apply_patch_with_msg \
    001-fix-build-on-mingw-w64.patch \
    002-fix-conflict-with-cmake-find-lapack.patch \
    003-make-tblite-independent-from-dftd4.patch \
    004-Fix-build-without-MPI.patch

  mv cmake/modules/FindLapack.cmake cmake/modules/Findcp2kLapack.cmake
  mv cmake/modules/FindBlas.cmake cmake/modules/Findcp2kBlas.cmake
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CARCH} == x86_64 ]]; then
    _extra_config+=("-DCP2K_USE_LIBXSMM=ON") #"-DCP2K_USE_ACCEL=OPENCL")
  fi

  FFLAGS=" -D__MINGW -D__NO_STATM_ACCESS -D__NO_SOCKETS" \
  CFLAGS+=" -D__NO_SOCKETS" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCP2K_USE_FFTW3=ON \
      -DCP2K_USE_HDF5=ON \
      -DCP2K_USE_LIBINT2=ON \
      -DCP2K_USE_LIBXC=ON \
      -DCP2K_USE_SPGLIB=ON \
      -DCP2K_USE_TBLITE=ON \
      -DCP2K_USE_MPI=OFF \
      -DCP2K_BLAS_VENDOR=OpenBLAS \
      -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      -Dcustom-lapack_FOUND=TRUE \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
